// Program downloader
// for v3.2 later
// 全機種対応

// 初期化 / initialize
font("IPAGothic")
int fzenhan
int WX=64:if deviceType()<>1 then WX=48
int WY=width(WX,,fzenhan)
int xw=1:/* 全角１文字の桁数 / zenkaku 1 character columus
if fzenhan then xw=2

str SPC=" ",TAB=chr$(9)

// リストファイルをダウンロードしてくる / Download list file
str listFile=localizedString("sampleJ.lst","sampleE.lst")
str baseURL ="http://www.asahi-net.or.jp/~YY8A-IMI/ipad/xb/sample/"
int ret=loadFromURL(listFile,baseURL,NO)
if ret<>0 then {
	print localizedString("ダウンロードリストファイルが見つかりません","Download list file is not found.");
	print ":";listFile;
	end
}

// リストファイルを開く / Open list file
int fp
fp=fopen(listFile,"r")
if fopenError(fp) then {
	print localizedString("ダウンロードリストファイルが開けません","Download list file can not open.")
	end
}
// 全ファイルリストを得る / get all file list
enum
	MAX_PROGRAMS=256:// 扱える最大プログラム数
endenum
dim str progNames(MAX_PROGRAMS)
dim str url(MAX_PROGRAMS)
int allcnt=readFileList(fp,progNames,url,MAX_PROGRAMS)
if allcnt<=0 then {
	print localizedString("リストファイルが異常です","The list file is broken.")
	end
}
fclose(fp)

if NO then {
	// test
	int i
	for i=0 to allcnt
		print i+1;" : ";progNames(i);",";url(i)
	next
}

// 選択処理

// タッチキー位置 / touch key area
int tx=WX-20:// <WX/2にすること
int ty=3
//
// 画面作成 / screen make
int lns=20:// 表示行数 / display lines
if lns>=WY-2 then lns=WY-2
makeScreen()
//
int top:// 表示している先頭行要素番号:fileList(top)
		// 表示範囲は(top)〜(top+lns-1)
int cur:// カーソル位置:0〜lns-1
tcolor(-THWHITE,0,0,255)
tborder(2,200,0,0)
tBackgroundColor(0,0,200,200)
int fafterMessage=NO
//
printList():// 最初の表示 / first list
repeat
	int top0=top,cur0=cur
	int fdownload=NO
	//
	int ky=inkey()
	switch ky
		// カーソル移動 / cursor move
		case '8'
			// カーソル上 / cursor up
			if fafterMessage then messageDisp("")
			if cur=0 then {
				if top>0 then top=top-1
			} else {
				cur=cur-1
			}
			break
		case '2'
			// カーソル下 / cursor down
			if fafterMessage then messageDisp("")
			if cur=lns-1 then {
				if top+lns<allcnt   then top=top+1
			} else {
				if top+cur<allcnt-1 then cur=cur+1
			}
			break
		// ページ単位移動 / page move
		case '4'
			// 前ページ / prev. page
			if fafterMessage then messageDisp("")
			if allcnt>lns then {
				// ページ切り替えが可能なとき / When paging is enabled
				top=top-(lns-1):// 1行残す / left 1 line
				if top<0 then top=0
			}
			break
		case '6'
			// 次ページ / next page
			if fafterMessage then messageDisp("")
			if allcnt>lns then {
				// ページ切り替えが可能なとき / When paging is enabled
				top=top+(lns-1):// 1行残す / left 1 line
				if top+lns>allcnt then {
					top=allcnt-lns
				}
			}
			break

		// ダウンロード / download
		case 'd'
			if fafterMessage then messageDisp("")
			allcnt=allcnt-1
			str title$
			dim str mn$(1)
			if isLocalizeJapan() then {
				mn$(0)="いいえ"
				mn$(1)="はい"
			} else {
				mn$(0)="NO"
				mn$(1)="YES"
			}
			str path=url(top+cur)
			if isLocalizeJapan() then {
				title$="このプログラムをダウンロードしますか？"://+chr$(DISP_CTRL_LF)+progNames(top+cur)
			} else {
				title$="Download this program ?"
			}
			if selectMenu(title$,mn$)=1 then {
				messageDisp(localizedString("ダウンロード中...","Now downloading..."))
				ret=loadFromURL(path,baseURL,NO)
				messageDisp(""):// 一旦メッセージを消す
				if ret=0 then {
					messageDisp(localizedString("展開中...","Now expanding..."))
					str fname=lastPathComponent(path)
					if zipExpand(fname)<0 then {
						beep()
						messageDisp(localizedString("Zipが展開出来ません","This zip file can not expand")+":"+fname)
					} else {
						messageDisp("")
					}
					// zipファイルを消す
					fdelete(fname)
				} else {
					beep()
					messageDisp(localizedString("ダウンロード出来ません","This is not able to download."))
				}
			}
			break
		
		default
			break
	endswitch
	if top<>top0 then {
		// ページが変わる / page changed
		printList()
		fdownload=NO
	} else {
		if cur<>cur0 then {
			// カーソル位置が変わった / cursor moved
			printList1(cur0) // 元の位置を反転解除 / non-reverse old position
			printList1(cur)	 // 新しい位置を反転 / revese new position
		}
	}
until ky='!'
end

//------------------------------------------------
// 関数 / functions
//------------------------------------------------

func makeScreen()
	// タッチキー / touch key
	dim int	touchNo(10)	:// タッチエリア番号 / touch area number
	int touchallcnt		:// タッチエリア数   / the number of touch area
	//
	int y=1+lns+1

	enum
		XC=4
		YC=1
	endenum
	int ky=(y+1)*32+8,kx=4
	int K1X=16*4,K1Y=16*4
	str dev=devicePlatform()
	if (left$(dev,4)<>"iPad") then {
		K1X=16*2
		K1Y=16*2
		kx=2
		ky=(y+1)*16-8
	}
	vpriority(GPAGE0,TPAGE,GPAGE1,GPAGE2,GPAGE3)
	vpage(B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)
	apage(GPAGE0)
	dim int keys( XC*YC-1)={'4','8','2','6'}
	dim str disps(XC*YC-1)={"<<","↑","↓",">>"}
	touchallcnt =setTouchKeys(kx,ky,XC,YC,K1X,K1Y,keys,disps,"Migu-1M-Regular",touchNo)

	// ファンクションキー / fucntion key
	str exit$,prev$,next$,download$
	if isLocalizeJapan() then {
		exit$="終了"
		prev$="<<前頁"
		next$="後頁>>"
		download$="ﾀﾞｳﾝﾛｰﾄﾞ"
	} else {
		exit$="exit"
		prev$="<<Prev"
		next$="Next>>"
		download$="Download"
	}
	setFunctionKey(0,prev$		,'4')
	setFunctionKey(1,next$		,'6')
	setFunctionKey(2,download$	,'d')
	setFunctionKey(3,exit$		,'!')
	setFunctionKeyBackgroundImage()
	displayFunctionKey(YES,0,3)
endfunc

//------------------------------------------------

func messageDisp(mes;str)
	locate(0,lns+1)
	if len(mes)=0 then {
		print chr$(DISP_CTRL_CLEARLINE) 
		fafterMessage=NO:// メッセージ表示してない / Message is not displaying
	} else {
		tColor(CTHRED)
		print mes
		tColor(CTHWHITE)
		fafterMessage=YES:// メッセージ表示中 / Now message is displaying
	}
endfunc

//------------------------------------------------

// 1行表示 / 1line display
func printList1(i;int)
	locate(0,1+i)
	if i=cur then tatrb(ATRB_REVERSE):// 選択行 / selected line
	if top+i<allcnt then {
		print using "###:";top+i+1; // 番号は1からにする / number starts 1
		print progNames(top+i);
	//	print lastPathComponent(fileList(top+i));
		if i=cur then tatrb(ATRB_NORMAL)
	}
	print chr$(DISP_CTRL_CLEARLINE):// 行末まで消す / clear to end of line
endfunc

// 画面内表示 / display in screen
func printList()
	int i
	int max=lns
	for i=0 to max-1
		printList1(i)
	next
endfunc

//------------------------------------------------

// リストファイルを読み込む / read list file
func int readFileList(fp;int,progNames();str,url();str,max;int)
	int cnt=0
	str line1,name
	while (freads(line1,fp)>0)
		// １行内の解析
		line1=skipSpaces(line1)
		if utf8Left$(line1,1)=";" then continue:// コメント行なので読み飛ばす / comment skip
		// "name" [SPC/TAB]* URL
		name=getName(line1):// プログラム名を得る / get prgram name
		line1=utf8Right$(line1,utf8Len(line1)-utf8Len(name))
		progNames(cnt)=name
		line1=skipSpaces(line1)
		name=getName(line1):// URLを得る / get URL
		url(cnt)=name:// URLといっても、ほとんどはファイル名(*.zip)
		cnt=cnt+1
	endwhile
	return (cnt)
endfunc

//------------------------------------------------

// 文字列の先頭から連続する半角スペースまたはタブを外す
// Remove a space or tab is continuous from the beginning of the string.
func str skipSpaces(s;str)
	str c
	int i=0
	repeat
		i=i+1
		c=utf8Mid$(s,i,1)
	until c<>SPC and c<>TAB
	return (utf8Right$(s,utf8Len(s)-(i-1)))
endfunc

//------------------------------------------------

// 文字列を(付いているなら""付きで)得る
// 終端は"で始まる時は"まで、そうでない時は半角スペースまたはタブまたは文字列終端
// 文字列先頭から連続する半角スペースまたはタブは削除しておくこと
// Get a string (if it start with " then with ")
// String terminater is space/tab character or end of string or " if it start with ".
// It is to be called after the skipSpaces().
func str getName(s;str)
	int i=1,fquote=NO
	str c,ss=""
	while YES
		c=utf8Mid$(s,i,1)
		i=i+1
		if c="" then break:// 文字列終端
		if fquote=NO and (c=SPC or c=TAB) then break:// "で始まってない時の終端
		if c=chr$(&h22) then {
			// "で始まっているときは、"は文字列に入れない
			if fquote then break:// すでに"があった場合は、ここが終端
			if i=1+1 then fquote=YES:continue:// 先頭に"があった時は""でくくられているとみなす
		}
		ss=ss+c
	endwhile
	return (ss)
endfunc

//------------------------------------------------

// デバッグ用表示 / print for debug
func dbgPrint(s;str)
	str c
	int i=1
	repeat
		c=utf8Mid$(s,i,1)
		if c="" then break
		if utf8(c)<' ' then print left$("0"+hex$(utf8(c)),2); else print c;
		i=i+1
	until NO
	print ,i
endfunc

//------------------------------------------------
